/* bo3-3.c ѭ(洢ṹc3-3.h)Ļ(9) */
#include "fifo.h"

static uint8_t front;
static uint8_t rear;
static fifo_elem_type fifo[MAXSIZE];

inline void fifo_init(void)
{
    front = rear = 0;
}
inline int fifo_is_empty()
{
    return (front == rear);
}
inline int fifo_is_full()
{
    return ((rear + 1) % MAXSIZE == front);
}
inline int fifo_get_length()
{
    return (rear - front + MAXSIZE) % MAXSIZE;
}

int fifo_get_head(fifo_elem_type * e)
{

    if (fifo_is_empty())
        return -1;
    *e = fifo[front];
    return 0;
}

int fifo_insert(fifo_elem_type e)
{
//  ԪeΪQµĶβԪ 

    if ((rear + 1) % MAXSIZE == front)  //  
        return -1;
    fifo[rear] = e;
    rear++;
    if (rear == MAXSIZE)
        rear = 0;

    return 0;
}

int fifo_del(fifo_elem_type * e)
{
// в,ɾQĶͷԪ,eֵ,OK;򷵻ERROR 

    if (fifo_is_empty())
        return -1;
    *e = fifo[front];
    front++;
    if (front == MAXSIZE)
        front = 0;
    return 0;
}

void fifo_traverse(void (*vi) (fifo_elem_type))
{
// ӶͷβζԶQÿԪصúvi().һviʧ,ʧ 

    int i;
    i = front;
    while (i != rear) {

        vi(fifo[i]);
        i = (i + 1) % MAXSIZE;
    }
}
